jQuery(document).ready(function($) {
    $('#export-button').on('click', function() {
        var role = $('#mw_export_role').val();
        var uid = $('#temporary_uid').val();
        var batch_size = $('#batch_size').val();

        $('#export-button').prop('disabled', true);
        
        var offset = 0;
        var limit = batch_size;
        var progressBar = $('#progress-bar');
        var progressText = $('#progress-text');
        progressBar.css('width', '0%');
        progressText.text('Starting export...');

        function exportBatch() {
            $.ajax({
                url: mw_export_data.ajax_url,
                method: 'POST',
                data: {
                    action: 'mw_export_users_callback',
                    nonce: mw_export_data.nonce,
                    role: role,
                    offset: offset,
                    limit: limit,
                    uid: uid
                },
                success: function(response) {
                    if (response.success) {
                        var batchCount = response.data.batch_count;
                        var results = response.data.results;

                        offset += batchCount;
                        var progressPercentage = Math.min((offset / 10000) * 100, 100); // You can adjust 10000 to actual total count if needed
                        progressBar.css('width', progressPercentage + '%');
                        progressText.text('Exported ' + offset + ' users...');

                        if (batchCount > 0) {
                            exportBatch();
                        } else {
                            progressText.text('Export Complete!');
                            $('#export-button').prop('disabled', false);
                        }
                    } else {
                        progressText.text('Error: ' + response.data.message);
                        $('#export-button').prop('disabled', false);
                    }
                },
                error: function() {
                    progressText.text('An error occurred during export.');
                    $('#export-button').prop('disabled', false);
                }
            });
        }

        exportBatch();
    });
});
